# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Protected Member Functions | Private Member Functions
dirac::EndOfSequenceByteIO Class Reference

Signals the end of a sequence in a Dirac-formatted bitstream. More...

`#include <endofsequence_byteio.h>`

Inheritance diagram for dirac::EndOfSequenceByteIO:

List of all members.

## Public Member Functions
| EndOfSequenceByteIO (const ByteIO &stream_data)
| Constructor.
| ~EndOfSequenceByteIO ()
| Destructor.
ParseUnitType | GetType () const
| Gets parse-unit type.
void | CollateByteStats (DiracByteStats &dirac_byte_stats)
| Gathers byte stats on the end of sequence data.
Public Member Functions inherited from dirac::ParseUnitByteIO
| ParseUnitByteIO ()
| Constructor.
| ParseUnitByteIO (const ByteIO &byte_io)
| Constructor.
| ParseUnitByteIO (const ParseUnitByteIO &parseunit_byteio)
| Constructor.
| ~ParseUnitByteIO ()
| Destructor.
bool | Input ()
| Reads from byte-stream to find parse data.
bool | IsValid ()
| Accesses validity of a unit by comparing it with an adjacent unit.
bool | CanSkip ()
| Can Skip past the entire parse-unit.
virtual const std::string | GetBytes ()
| Gets string containing coded bytes.
void | SetAdjacentParseUnits (ParseUnitByteIO *p_prev_parseunit)
| Set next/previous parse-unit values.
virtual int | GetSize () const
| *Gets size (in bytes)
int | GetNextParseOffset () const
| Gets expected number of bytes to start of next parse-unit.
int | GetPreviousParseOffset () const
| Gets number of bytes to start of previous parse-unit.
bool | IsSeqHeader () const
| Returns true is parse unit is a Sequence Header.
bool | IsEndOfSequence () const
| Returns true is parse unit is an End of Sequence unit.
bool | IsAuxiliaryData () const
| Returns true is parse unit is Auxiliary Data.
bool | IsPaddingData () const
| Returns true is parse unit is Padding data.
bool | IsPicture () const
| Returns true is parse unit is Picture data.
bool | IsLowDelay () const
| Returns true is parse unit is Low Delay Sybtax unit.
bool | IsCoreSyntax () const
| Returns true is parse unit is Core syntax unit.
bool | IsUsingAC () const
| Returns true is parse unit uses Arithmetic coding.
Public Member Functions inherited from dirac::ByteIO
| ByteIO (bool new_stream=true)
| Default constructor.
| ByteIO (const ByteIO &stream_data)
| Constructor.
virtual | ~ByteIO ()
| Destructor.
int | GetReadBytePosition () const
| Get position of read stream pointer.
void | SetByteParams (const ByteIO &byte_io)
| Copies stream source/destination info.
void | ByteAlignOutput ()
| Sync input for byte-alignment.
void | WriteUint (unsigned int value)
| Ouputs an unsigned integer in interleaved exp Golomb format.
void | SetBitsLeft (int left_bits)
| Sets input size in bits.
int | BitsLeft (void)
| Sets input size in bits.

## Protected Member Functions
int | CalcNextUnitOffset ()
| Calculates number of bytes to start of next unit.
Protected Member Functions inherited from dirac::ParseUnitByteIO
bool | SyncToUnitStart ()
| Locates start of parse-unit.
unsigned char | GetParseCode () const
| Get parse code.
Protected Member Functions inherited from dirac::ByteIO
bool | CanRead () const
bool | GetBit (unsigned char &c, int pos) const
void | SetBit (unsigned char &c, int pos) const
void | SetBits (unsigned char &c, unsigned char bits) const
void | ByteAlignInput ()
| Sync input for byte-alignment.
bool | ReadBool ()
| Reads boolean value.
bool | ReadBoolB ()
| Reads boolean value - bounded i/o.
int | ReadBit ()
| Reads next bit.
int | ReadBitB ()
| Reads next bit - bounded i/o.
unsigned int | ReadNBits (int count)
| Reads next 'count' bits.
void | InputBytes (char *data, int count)
| Reads from stream.
void | FlushInputB ()
| Flushes the bounde input.
int | ReadSint ()
| Reads a signed integer in interleaved exp-Golomb format *return Signed integer read.
int | ReadSintB ()
| Reads a signed integer in interleaved exp-Golomb format from bounded input *return Signed integer read.
unsigned int | ReadUint ()
| Reads an unsigned integer in interleaved exp Golomb format.
unsigned int | ReadUintB ()
| Reads an unsigned integer in interleaved exp Golomb format from bounded input.
unsigned int | ReadUintLit (const int byte_size)
| Reads a fixed length unsigned integer from the stream in big endian.
unsigned char | InputUnByte ()
| Reads a byte from the stream.
std::string | InputUnString (const int count)
| Reads a series of bytes from a stream.
void | WriteBit (const bool &bit)
| Outputs a bit.
int | WriteNBits (unsigned int val)
| Outputs an unsigned integer.
void | WriteNBits (unsigned int val, int count)
| Outputs an n bit integer.
void | OutputBytes (const std::string &bytes)
| Outputs a series of bytes.
void | OutputCurrentByte ()
| Outputs current byte contents.
void | WriteSint (int val)
| Outputs an integer in Golomb signed integer format.
void | WriteUintLit (const unsigned int &value, const int &length)
| Output unsigned int value in big endian format.
void | RemoveRedundantBytes (const int count)
| Removes portion of byte-stream no longer required.
void | SeekGet (const int offset, std::ios_base::seekdir dir)

## Private Member Functions
unsigned char | CalcParseCode () const
| Calculates parse-code based on picture parameters.

## Detailed Description

Current Accessunit parameters are no longer valid for subsequent frames

## Constructor & Destructor Documentation

dirac::EndOfSequenceByteIO::EndOfSequenceByteIO | ( | const ByteIO & | stream_data | ) |

Parameters:

  stream_data | Stream parameters

dirac::EndOfSequenceByteIO::~EndOfSequenceByteIO | ( |  | ) |

## Member Function Documentation

int dirac::EndOfSequenceByteIO::CalcNextUnitOffset | ( |  | ) |
| inline protected virtual

Returns:
  Zero(0) End of sequence does not specify a 'next'unit

Reimplemented from dirac::ParseUnitByteIO.

unsigned char dirac::EndOfSequenceByteIO::CalcParseCode | ( |  | ) | const
| private virtual

Returns:
  Char bit-set

Reimplemented from dirac::ParseUnitByteIO.

void dirac::EndOfSequenceByteIO::CollateByteStats | ( | DiracByteStats & | dirac_byte_stats | ) |
| virtual

Parameters:

  dirac_byte_stats | Stat container

Reimplemented from dirac::ParseUnitByteIO.

ParseUnitType dirac::EndOfSequenceByteIO::GetType | ( |  | ) | const
| inline virtual

Reimplemented from dirac::ParseUnitByteIO.

References dirac::PU_END_OF_SEQUENCE.

The documentation for this class was generated from the following file:

- endofsequence_byteio.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.